<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="GENERATOR" content="Mozilla/4.5 [fr]C-CCK-MCD {World Online}  (WinNT; I) [Netscape]">
</head>
<body background="../images/fondINRA.jpg">
&nbsp;
<table WIDTH="100%" NOSAVE >
<tr>
<td>
<center>
<h1>
<a href="logiciel.html"><img SRC="../images/french.gif" height=25 width=36></a></h1></center>
</td>

<td>
<center>
<h1>
<i>SEPATOU : simulator of rotational grazing management in a dairy production
system</i></h1></center>
</td>

<td>
<center>
<h1>
<img SRC="../images/english.gif" height=25 width=34></h1></center>
</td>
</tr>
</table>

<table COLS=5 WIDTH="100%" BGCOLOR="#00FF00" NOSAVE >
<tr>
<td>
<center><font size=+1><a href="../presentation/presentationE.html">Presentation</a></font></center>
</td>

<td>
<center><font size=+1><a href="../modelisation/modelisationE.html">Modeling</a></font></center>
</td>

<td>
<center><font size=+1>Software</font></center>
</td>

<td>
<center><font size=+1><a href="../demonstration/demonstrationE.html">Demonstration</a></font></center>
</td>

<td>
<center><font size=+1><a href="../documentation/documentationE.html">Documentation</a></font></center>
</td>
</tr>
</table>

<br>&nbsp;
<center>
<h1>
Software</h1></center>

<center>
<hr WIDTH="100%"></center>

<p><br>
<h3>
Implementation (Code available on <a href="https://sourcesup.renater.fr/frs/?group_id=3694">SourceSup</a>)</h3>
The SEPATOU software is a discrete event simulator with time management
directed by clock.
<br>It is composed of two parts:
<ul>
<li>
the user interface essentialy developped with <a href="http://www.scriptics.com/" target="_parent">Tcl/Tk</a>,</li>

<li>
the heart of the simulator, developped with an object approach in <a href="http://gcc.gnu.org/" target="_parent">GNU
C++</a>.</li>
</ul>

<center>
<p><br><img SRC="programmationE.gif" height=293 width=392></center>

<p><br>
<h3>
The heart of the simulator</h3>
The discrete-event simulator at the core of SEPATOU is designed to work
as follows. Every day it checks whether a noticeable event has occurred,
and if so, the plans attached to the activities are eventually created
or adapted, using planning rules. By using action rules the general instructions
specified in the plans are then transformed into executable actions that
depend on the current situation of the biophysical system (more precisely
on the decision maker perception of the current situation), the external
environment and the current date. The changes that the actions cause on
the biophysical system are then computed, resulting in a milk production
figure for this day and an updating of the biophysical state that corresponds
at this point to the situation at the beginning of the next day.&nbsp;
The simulator then considers the next day and performs a similar processing.
The iterations are pursued until the end of the simulated period.
<h3>
Use of the software: a three-step process</h3>
The user must first describe the following inputs:
<ul>
<li>
a farm: fields, a herd of cows, stocks of maize silage and hay,</li>

<li>
a strategy: planning rules, acting rules, indicators and interpretation
functions,</li>

<li>
a set of climates (real or generated) to simulate,</li>

<li>
desired outputs after simulation.</li>
</ul>
The desired outputs need to be specified because their number affects the
time of simulation. For a PC computer with a Pentium III at 500 MHz, the
speed of simulation is 2.3 simulations par second when all possible outputs
are desired and 8.3 simulations per second for the minimum outputs which
are average values for each realized simulation.
<p>The second step encompasses a pre-processing phase and the running of
the simulations. The pre-processing consists in parsing and then translating
the strategy from the LnU language specifically developed for strategy
representation into the C++ programming language in which the simulator
is implemented. The translated strategy must then be compiled and linked
with the code of the simulation mechanism. At this stage simulations with
different climate scenorios can be run.
<p>In the third step, the user can visualise the outputs of simulations.
A set of display options is provided for helping to analyse the results.
The time series of any user-selected variable throughout a set of simulated
years can be visualised: for example, the diet composition throughout one
particular year, or the chronicle of the executed actions concerning rotations,
silage cutting, hay cutting and fertilisation on each pasture.
<br>&nbsp;
<br>&nbsp;
<br>
<center>
<p><img SRC="utilisationE.gif" height=290 width=504></center>

<p>If the results are not satisfying , the user migth modify the strategy
and vizualize the newly obtained results.
<br>During this trial-and-error process, the user better apprehends the
functionning of the considered complex production system and learns to
better manage it.
<center>
<p><img SRC="utilisation_ecransE.gif" height=624 width=691>
<p>
<hr WIDTH="100%"><font size=-1>Last modifications: January 2018</font></center>

</body>
</html>
